#pragma once

#include "IDTVPlugin.h"
#include "TsStreamEngine/TsStream.h"
#include <map>
#include <vector>

typedef std::vector<WORD>		PidList;
typedef std::map<WORD,PidList>	ServiceMap;
typedef std::pair<WORD,PidList>	ServicePair;

class CSamplePlugin : public IDTVPlugin
{
public:
    HWND m_hWnd;							    // dialog window
    HMODULE m_hModule;							    // dll handle
    IDTVApp *m_pIDtvApp;						    // host app pointer

    CSamplePlugin(HMODULE hModule);

    // IDTVPlugin
    BOOL WINAPI Init(HWND AppWindow);
    BOOL WINAPI ProcessTS(BYTE *Buffer, DWORD Length);
    BOOL WINAPI SetHostAPI(IDTVApp *Application, DWORD Version);
    BOOL WINAPI OnStreamChange(int Channel, int ServiceID);
    BOOL WINAPI OnFileSave(TCHAR *FileName, DWORD Length);

    // Window-related
    INT_PTR DialogProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp);
    
	CTsStream m_TsStream;
	struct TS_StreamInfo	m_stStreamInfo;
	int m_iServiceID;
	ServiceMap m_Service;

	void AddString(wchar_t *str);
	static void CALLBACK TsCallback(UINT uType,WORD wStreamID,LPVOID pData,DWORD dwVal,LPVOID lpContext);

};
