#include "stdafx.h"
#include "TsEpgMgr.h"
#include <vector>
#include <algorithm>

CTsEPGMgr::CTsEPGMgr(void)
{
	CLock::CreateLockObj(&m_EpgLock);
}

CTsEPGMgr::~CTsEPGMgr(void)
{
	Clear();
	CLock::DestroyLockObj(&m_EpgLock);
}

// Sf[^폜
void CTsEPGMgr::Clear()
{
	CLock cEpgLock(&m_EpgLock);
	TSEpg_ServiceMap::iterator itMap;
	for(itMap=m_EpgDB.begin();itMap!=m_EpgDB.end();itMap++)
	{
		TSEpg_Map *pEpg=itMap->second;
		TSEpg_Map::iterator itData;
		size_t i=pEpg->size();
		for(itData=pEpg->begin();itData!=pEpg->end();itData++)
		{
			// Imۃf[^J
		}
		// ŏIJ
		pEpg->clear();
		delete pEpg;
	}
	m_EpgDB.clear();
}

// wT[rX̃f[^폜
void CTsEPGMgr::ClearEpg(WORD wServiceID)
{
	CLock cEpgLock(&m_EpgLock);
	TSEpg_ServiceMap::iterator itMap=m_EpgDB.find(wServiceID);
	if(itMap!=m_EpgDB.end())
	{
		TSEpg_Map *pEpg=itMap->second;
		TSEpg_Map::iterator itData;
		size_t i=pEpg->size();
		for(itData=pEpg->begin();itData!=pEpg->end();itData++)
		{
			// Imۃf[^J
		}
		// ŏIJ
		pEpg->clear();
		delete pEpg;
		// Xg菜
		m_EpgDB.erase(wServiceID);
	}
}

// EPGf[^x[Xɓo^ĂT[rX̐擾B
int CTsEPGMgr::GetEpgServiceCount()
{
	CLock cEpgLock(&m_EpgLock);
	return static_cast<int>(m_EpgDB.size());
}

// EPGf[^x[Xɓo^ĂT[rXID̃Xg(WORDz)擾B
// 擾|C^͎gp FreeEpgServiceList() ɂĊJ(̈Ⴂz邽)
BOOL CTsEPGMgr::GetEpgServiceList(WORD **ppList,int *piNum)
{
	CLock cEpgLock(&m_EpgLock);
	WORD *pRet=new WORD[m_EpgDB.size()];
	if(pRet)
	{
		TSEpg_ServiceMap::iterator it;
		int iCount=0;
		for(it=m_EpgDB.begin();it!=m_EpgDB.end();it++)
		{
			pRet[iCount++]=it->first;
		}
		*ppList=pRet;
		*piNum=static_cast<int>(m_EpgDB.size());
		return TRUE;
	}
	return FALSE;
}

// GetEpgServiceList()Ŏ擾f[^̊J
void CTsEPGMgr::FreeEpgServiceList(WORD *pList,int iNum)
{
	if(pList) delete []pList;
}

// EPG}bvɓo^ꂢf[^̐擾B
int CTsEPGMgr::GetEpgDataCount(TSEpg_Map *pEpg)
{
	CLock cEpgLock(&m_EpgLock);
	if(pEpg)
	{
		return static_cast<int>(pEpg->size());
	}
	return 0;
}

static int stl_sort_func_cmp(struct TSEPG_PROGRAM& a, struct TSEPG_PROGRAM& b)
{
	if(a.stStart.Date==b.stStart.Date)
	{
		// tȂJnŃ\[g
		return a.stStart.Time < b.stStart.Time;
	} else {
		// ႤtȂt傫ق
		return a.stStart.Date < b.stStart.Date;
	}
}

// EPGf[^x[Xɓo^ĂT[rXID̃Xg(struct TSEPG_PROGRAM z)擾B
// 擾|C^͎gp FreeEpgDataList() ɂĊJ(̈Ⴂz邽)
BOOL CTsEPGMgr::GetEpgDataList(TSEpg_Map *pEpg,struct TSEPG_PROGRAM **ppList,int *piNum)
{
	CLock cEpgLock(&m_EpgLock);
	if(pEpg)
	{
		struct TSEPG_PROGRAM *pRet=new TSEPG_PROGRAM[pEpg->size()];
		if(pRet)
		{
			TSEpg_Map::iterator it;
			int iCount=0;
			for(it=pEpg->begin();it!=pEpg->end();it++)
			{
				memcpy(&pRet[iCount++],&it->second,sizeof(struct TSEPG_PROGRAM));
				// I̊mہARs[
			}
		}
		std::sort(pRet,pRet+pEpg->size(),stl_sort_func_cmp);
		*ppList = pRet;
		*piNum = static_cast<int>(pEpg->size());		
		return TRUE;
	}
	return FALSE;
}

// GetEpgDataList()Ŏ擾f[^̊J
void CTsEPGMgr::FreeEpgDataList(TSEpg_Map *pEpg,struct TSEPG_PROGRAM *pList,int iNum)
{
	if(pList)
	{
		for(int i=0;i<iNum;i++)
		{
			// Imۃ̊J
		}
		delete []pList;
	}
}

// w肵T[rXIDEPG}bvւ̃|C^擾B
// bFlg=TRUE A݂Ȃf[^̏ꍇÃf[^쐬
// ݂ȂꍇNULL
TSEpg_Map* CTsEPGMgr::GetEpgMap(WORD wServiceID,BOOL bNewFlg)
{
	TSEpg_ServiceMap::iterator it = m_EpgDB.find(wServiceID);
	if(it!=m_EpgDB.end())
	{
		return it->second;
	}
	else if(bNewFlg)
	{
		TSEpg_Map *pNew = new TSEpg_Map;
		if(!pNew) return NULL;
		m_EpgDB.insert(TSEpg_ServiceMapPair(wServiceID,pNew));
		it = m_EpgDB.find(wServiceID);
		if(it!=m_EpgDB.end())
		{
			// ɒǉ
			return it->second;
		}
	}
	return NULL;
}

// w肵CxgIDEPGf[^ւ̃|C^擾B
// ݂ȂꍇNULL
struct TSEPG_PROGRAM* CTsEPGMgr::GetEpgData(TSEpg_Map *pEpg,WORD wEventID)
{
	if(pEpg)
	{
		TSEpg_Map::iterator it = pEpg->find(wEventID);
		if(it!=pEpg->end())
		{
			return &it->second;
		}
	}
	return NULL;
}

// w肵T[rXID̃f[^ǉA܂͍XV
BOOL CTsEPGMgr::SetEpgData(WORD wServiceID,struct TSEPG_PROGRAM *pstNewData)
{
	CLock cEpgLock(&m_EpgLock);
	TSEpg_Map *pEpg = GetEpgMap(wServiceID,TRUE);
	if(!pEpg) return FALSE;

	struct TSEPG_PROGRAM *pData=GetEpgData(pEpg,pstNewData->wEventID);
	if(pData)
	{
		// XV(Dx̍̂ł΁AXV)
		if(pData->byType>pstNewData->byType || (pData->byType==pstNewData->byType && pData->byVersion!=pstNewData->byVersion))
		{
			*pData = *pstNewData;
			return TRUE;
		}
	} else {
		// VKǉ
		pEpg->insert(TSEpg_MapPair(pstNewData->wEventID,*pstNewData));
		return TRUE;
	}
	return FALSE;
}

// wA̔ԑgCxgBȂꍇNULL
// bDeleteMode=TRUE̎AwȑÕf[^͍폜
struct TSEPG_PROGRAM* CTsEPGMgr::FindEpgDataByTime(WORD wServiceID,DateTime &stSearch,BOOL bDeleteMode)
{
	CLock cEpgLock(&m_EpgLock);
	TSEpg_Map *pEpg = GetEpgMap(wServiceID);
	if(!pEpg) return NULL;

	TSEpg_Map::iterator itProg;
	std::vector<WORD> EpgDeleteEventIDList;
	bool bFindFlg=FALSE;
	struct TSEPG_PROGRAM* pFindProg=NULL;

	for(itProg=pEpg->begin();itProg!=pEpg->end();itProg++)
	{
		struct TSEPG_PROGRAM &stProg=itProg->second;
		// 
		if(stProg.stEnd.Time != TimeVal_Unknown)
		{
			// Jn`ÎPbO(IԂ͎̔ԑg̊JnԂ̂)
			bFindFlg=CDateTime::Check_Time(stProg.stStart,0,stProg.stEnd,-1,stSearch,0);
		} else {
			// Jn`
			bFindFlg=CDateTime::Compare_Time(stProg.stStart,0,stSearch,0)<0?true:false;
		}
		if(bFindFlg && !pFindProg)
		{
			pFindProg = new TSEPG_PROGRAM;
			if(pFindProg)
			{
				*pFindProg = stProg;
				// I̊mہARs[
			}
		}
		// DeleteȂݒŃf[^ĂΌI
		if(!bDeleteMode && pFindProg) break;
		// 폜邩
		if(bDeleteMode)
		{
			BOOL bDeleteFlg=FALSE;
			if(stProg.stEnd.Time != TimeVal_Unknown)
			{
				bDeleteFlg=CDateTime::Compare_Time(stProg.stEnd,0,stSearch,0)<0?true:false;
			}
			if(bDeleteFlg)
			{
				EpgDeleteEventIDList.push_back(itProg->first);
			}
		}
	}
	// 폜tÔ̂菜
	for(unsigned int i=0;i<EpgDeleteEventIDList.size();i++)
	{
		pEpg->erase(EpgDeleteEventIDList[i]);
#ifdef TSEITPARSER_DEBUG_PRINT
		char buf[80];
		wsprintf(buf,"DELETE EPG Service=%d Event=0x%04X DataNum=%d\n",wServiceID,EpgDeleteEventIDList[i],pEpg->size());
		OutputDebugStr(buf);
#endif
	}
	return pFindProg;
}

// ̎łNetworkIDStreamIDł̔͂Ȃ
struct TSEPG_PROGRAM* CTsEPGMgr::FindEpgDataByEventID(WORD wNetworkID,WORD wStreamID,WORD wServiceID,WORD wEventID)
{
	CLock cEpgLock(&m_EpgLock);
	TSEpg_Map *pEpg = GetEpgMap(wServiceID);
	if(!pEpg) return NULL;

	TSEpg_Map::iterator itProg;
	bool bFindFlg=FALSE;
	struct TSEPG_PROGRAM* pFindProg=NULL;
	for(itProg=pEpg->begin();itProg!=pEpg->end()&&!pFindProg;itProg++)
	{
		struct TSEPG_PROGRAM &stProg=itProg->second;
		// 
		if(wEventID==stProg.wEventID) bFindFlg=TRUE;
	
		if(bFindFlg && !pFindProg)
		{
			pFindProg = new TSEPG_PROGRAM;
			if(pFindProg)
			{
				*pFindProg = stProg;
				// I̊mہARs[
			}
		}
	}
	return pFindProg;
}

// 擾EPGf[^̊J
void CTsEPGMgr::FreeEpgDataMemory(struct TSEPG_PROGRAM *pData,int iCount )
{
	for(int i=0;i<iCount;i++)
	{
		// I̊J
	}
	delete pData;
}

// w肵ԂÕf[^폜(Service=0xFFFFȂST[rXΏ)
void CTsEPGMgr::DeleteEpgDataByTime(DateTime &stDeleteTime,WORD wServiceID)
{
	CLock cEpgLock(&m_EpgLock);
	if(wServiceID!=0xFFFF)
	{
		// T[rX
		TSEpg_Map *pEpg = GetEpgMap(wServiceID);
		if(!pEpg) return;

		TSEpg_Map::iterator itProg;
		std::vector<WORD> EpgDeleteEventIDList;
		for(itProg=pEpg->begin();itProg!=pEpg->end();itProg++)
		{
			struct TSEPG_PROGRAM &stProg=itProg->second;
			if(stProg.stEnd.Time != TimeVal_Unknown)
			{
				if(CDateTime::Compare_Time(stProg.stEnd,0,stDeleteTime,0)<0)
				{
					// 폜Ώ(Io)
					EpgDeleteEventIDList.push_back(itProg->first);
				}
			}
		}
		// 폜tÔ̂菜
		for(unsigned int i=0;i<EpgDeleteEventIDList.size();i++)
		{
			pEpg->erase(EpgDeleteEventIDList[i]);
#ifdef TSEITPARSER_DEBUG_PRINT
			char buf[80];
			wsprintf(buf,"DELETE EPG Service=%d Event=0x%04X DataNum=%d\n",wServiceID,EpgDeleteEventIDList[i],pEpg->size());
			OutputDebugStr(buf);
#endif
		}		
	} else {
		// ST[rX
		TSEpg_ServiceMap::iterator it;
		for(it=m_EpgDB.begin();it!=m_EpgDB.end();it++)
		{
			DeleteEpgDataByTime(stDeleteTime,it->first);
		}
	}
}

#ifdef _DEBUG
void CTsEPGMgr::DebugDump(WORD wServiceID,char *lpszOutputPath)
{
	CLock cEpgLock(&m_EpgLock);
	TSEpg_Map *pEpg = GetEpgMap(wServiceID);
	if(!pEpg) return;

	TSEpg_Map::iterator itProg;
	TsEpg_Vector vec;

	int i;
	vec.resize(pEpg->size());
	for(itProg=pEpg->begin(),i=0;itProg!=pEpg->end();itProg++)
	{
		vec[i++]=itProg->second;
	}
	std::sort(vec.begin(),vec.end(),stl_sort_func_cmp);

	FILE *fp=fopen(lpszOutputPath,"wt");
	if(fp)
	{
		fprintf(fp,"ServiceNo=%d\n",wServiceID);
		int i,n=static_cast<int>(vec.size());		
		for(i=0;i<n;i++)
		{
			TSEPG_PROGRAM &stItem=vec[i];
			long year,month,day,hour,min,sec,e_hour,e_min,e_sec;

			CDateTime::ConvertFrom_MJD(stItem.stStart.Date,year,month,day);
			CDateTime::ConvertFrom_TimeSec(stItem.stStart.Time,hour,min,sec);
			CDateTime::ConvertFrom_TimeSec(stItem.stEnd.Time,e_hour,e_min,e_sec);
			fprintf(fp,"%d(%02x) %04d/%02d/%02d(%s) %02d:%02d:%02d-%02d:%02d:%02d[%04X:%04X]",
				stItem.byType,stItem.byVersion,
				year,month,day,CDateTime::GetWeekDayString(stItem.stStart.Date),
				hour,min,sec,e_hour,e_min,e_sec,
				stItem.wServiceID,stItem.wEventID
				);
			fprintf(fp,"[%-80s][%s]\n",stItem.szTitle,stItem.szText);
		}
		fclose(fp);
	}
}
#endif